// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/google/uuid"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/item"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/itemmeta"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/predicate"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/user"
)

// ItemUpdate is the builder for updating Item entities.
type ItemUpdate struct {
	config
	hooks    []Hook
	mutation *ItemMutation
}

// Where appends a list predicates to the ItemUpdate builder.
func (iu *ItemUpdate) Where(ps ...predicate.Item) *ItemUpdate {
	iu.mutation.Where(ps...)
	return iu
}

// SetName sets the "name" field.
func (iu *ItemUpdate) SetName(s string) *ItemUpdate {
	iu.mutation.SetName(s)
	return iu
}

// SetAmount sets the "amount" field.
func (iu *ItemUpdate) SetAmount(f float64) *ItemUpdate {
	iu.mutation.ResetAmount()
	iu.mutation.SetAmount(f)
	return iu
}

// AddAmount adds f to the "amount" field.
func (iu *ItemUpdate) AddAmount(f float64) *ItemUpdate {
	iu.mutation.AddAmount(f)
	return iu
}

// SetOriginalAmount sets the "original_amount" field.
func (iu *ItemUpdate) SetOriginalAmount(f float64) *ItemUpdate {
	iu.mutation.ResetOriginalAmount()
	iu.mutation.SetOriginalAmount(f)
	return iu
}

// AddOriginalAmount adds f to the "original_amount" field.
func (iu *ItemUpdate) AddOriginalAmount(f float64) *ItemUpdate {
	iu.mutation.AddOriginalAmount(f)
	return iu
}

// SetUserID sets the "user_id" field.
func (iu *ItemUpdate) SetUserID(u uuid.UUID) *ItemUpdate {
	iu.mutation.SetUserID(u)
	return iu
}

// SetRefID sets the "ref_id" field.
func (iu *ItemUpdate) SetRefID(s string) *ItemUpdate {
	iu.mutation.SetRefID(s)
	return iu
}

// SetNillableRefID sets the "ref_id" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableRefID(s *string) *ItemUpdate {
	if s != nil {
		iu.SetRefID(*s)
	}
	return iu
}

// ClearRefID clears the value of the "ref_id" field.
func (iu *ItemUpdate) ClearRefID() *ItemUpdate {
	iu.mutation.ClearRefID()
	return iu
}

// SetBuyURL sets the "buy_url" field.
func (iu *ItemUpdate) SetBuyURL(s string) *ItemUpdate {
	iu.mutation.SetBuyURL(s)
	return iu
}

// SetNillableBuyURL sets the "buy_url" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableBuyURL(s *string) *ItemUpdate {
	if s != nil {
		iu.SetBuyURL(*s)
	}
	return iu
}

// ClearBuyURL clears the value of the "buy_url" field.
func (iu *ItemUpdate) ClearBuyURL() *ItemUpdate {
	iu.mutation.ClearBuyURL()
	return iu
}

// SetThumbnail sets the "thumbnail" field.
func (iu *ItemUpdate) SetThumbnail(s string) *ItemUpdate {
	iu.mutation.SetThumbnail(s)
	return iu
}

// SetNillableThumbnail sets the "thumbnail" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableThumbnail(s *string) *ItemUpdate {
	if s != nil {
		iu.SetThumbnail(*s)
	}
	return iu
}

// ClearThumbnail clears the value of the "thumbnail" field.
func (iu *ItemUpdate) ClearThumbnail() *ItemUpdate {
	iu.mutation.ClearThumbnail()
	return iu
}

// SetSku sets the "sku" field.
func (iu *ItemUpdate) SetSku(s string) *ItemUpdate {
	iu.mutation.SetSku(s)
	return iu
}

// SetNillableSku sets the "sku" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableSku(s *string) *ItemUpdate {
	if s != nil {
		iu.SetSku(*s)
	}
	return iu
}

// ClearSku clears the value of the "sku" field.
func (iu *ItemUpdate) ClearSku() *ItemUpdate {
	iu.mutation.ClearSku()
	return iu
}

// SetCurrency sets the "currency" field.
func (iu *ItemUpdate) SetCurrency(s string) *ItemUpdate {
	iu.mutation.SetCurrency(s)
	return iu
}

// SetNillableCurrency sets the "currency" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableCurrency(s *string) *ItemUpdate {
	if s != nil {
		iu.SetCurrency(*s)
	}
	return iu
}

// SetNativeAmount sets the "native_amount" field.
func (iu *ItemUpdate) SetNativeAmount(f float64) *ItemUpdate {
	iu.mutation.ResetNativeAmount()
	iu.mutation.SetNativeAmount(f)
	return iu
}

// SetNillableNativeAmount sets the "native_amount" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableNativeAmount(f *float64) *ItemUpdate {
	if f != nil {
		iu.SetNativeAmount(*f)
	}
	return iu
}

// AddNativeAmount adds f to the "native_amount" field.
func (iu *ItemUpdate) AddNativeAmount(f float64) *ItemUpdate {
	iu.mutation.AddNativeAmount(f)
	return iu
}

// ClearNativeAmount clears the value of the "native_amount" field.
func (iu *ItemUpdate) ClearNativeAmount() *ItemUpdate {
	iu.mutation.ClearNativeAmount()
	return iu
}

// SetCondition sets the "condition" field.
func (iu *ItemUpdate) SetCondition(s string) *ItemUpdate {
	iu.mutation.SetCondition(s)
	return iu
}

// SetNillableCondition sets the "condition" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableCondition(s *string) *ItemUpdate {
	if s != nil {
		iu.SetCondition(*s)
	}
	return iu
}

// SetStock sets the "stock" field.
func (iu *ItemUpdate) SetStock(i int) *ItemUpdate {
	iu.mutation.ResetStock()
	iu.mutation.SetStock(i)
	return iu
}

// SetNillableStock sets the "stock" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableStock(i *int) *ItemUpdate {
	if i != nil {
		iu.SetStock(*i)
	}
	return iu
}

// AddStock adds i to the "stock" field.
func (iu *ItemUpdate) AddStock(i int) *ItemUpdate {
	iu.mutation.AddStock(i)
	return iu
}

// SetCreatedAt sets the "created_at" field.
func (iu *ItemUpdate) SetCreatedAt(t time.Time) *ItemUpdate {
	iu.mutation.SetCreatedAt(t)
	return iu
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (iu *ItemUpdate) SetNillableCreatedAt(t *time.Time) *ItemUpdate {
	if t != nil {
		iu.SetCreatedAt(*t)
	}
	return iu
}

// SetUpdatedAt sets the "updated_at" field.
func (iu *ItemUpdate) SetUpdatedAt(t time.Time) *ItemUpdate {
	iu.mutation.SetUpdatedAt(t)
	return iu
}

// SetUser sets the "user" edge to the User entity.
func (iu *ItemUpdate) SetUser(u *User) *ItemUpdate {
	return iu.SetUserID(u.ID)
}

// AddMetumIDs adds the "meta" edge to the ItemMeta entity by IDs.
func (iu *ItemUpdate) AddMetumIDs(ids ...uuid.UUID) *ItemUpdate {
	iu.mutation.AddMetumIDs(ids...)
	return iu
}

// AddMeta adds the "meta" edges to the ItemMeta entity.
func (iu *ItemUpdate) AddMeta(i ...*ItemMeta) *ItemUpdate {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return iu.AddMetumIDs(ids...)
}

// Mutation returns the ItemMutation object of the builder.
func (iu *ItemUpdate) Mutation() *ItemMutation {
	return iu.mutation
}

// ClearUser clears the "user" edge to the User entity.
func (iu *ItemUpdate) ClearUser() *ItemUpdate {
	iu.mutation.ClearUser()
	return iu
}

// ClearMeta clears all "meta" edges to the ItemMeta entity.
func (iu *ItemUpdate) ClearMeta() *ItemUpdate {
	iu.mutation.ClearMeta()
	return iu
}

// RemoveMetumIDs removes the "meta" edge to ItemMeta entities by IDs.
func (iu *ItemUpdate) RemoveMetumIDs(ids ...uuid.UUID) *ItemUpdate {
	iu.mutation.RemoveMetumIDs(ids...)
	return iu
}

// RemoveMeta removes "meta" edges to ItemMeta entities.
func (iu *ItemUpdate) RemoveMeta(i ...*ItemMeta) *ItemUpdate {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return iu.RemoveMetumIDs(ids...)
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (iu *ItemUpdate) Save(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	iu.defaults()
	if len(iu.hooks) == 0 {
		if err = iu.check(); err != nil {
			return 0, err
		}
		affected, err = iu.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ItemMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = iu.check(); err != nil {
				return 0, err
			}
			iu.mutation = mutation
			affected, err = iu.sqlSave(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(iu.hooks) - 1; i >= 0; i-- {
			if iu.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = iu.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, iu.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// SaveX is like Save, but panics if an error occurs.
func (iu *ItemUpdate) SaveX(ctx context.Context) int {
	affected, err := iu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (iu *ItemUpdate) Exec(ctx context.Context) error {
	_, err := iu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (iu *ItemUpdate) ExecX(ctx context.Context) {
	if err := iu.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (iu *ItemUpdate) defaults() {
	if _, ok := iu.mutation.UpdatedAt(); !ok {
		v := item.UpdateDefaultUpdatedAt()
		iu.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (iu *ItemUpdate) check() error {
	if _, ok := iu.mutation.UserID(); iu.mutation.UserCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "Item.user"`)
	}
	return nil
}

func (iu *ItemUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := &sqlgraph.UpdateSpec{
		Node: &sqlgraph.NodeSpec{
			Table:   item.Table,
			Columns: item.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: item.FieldID,
			},
		},
	}
	if ps := iu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := iu.mutation.Name(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldName,
		})
	}
	if value, ok := iu.mutation.Amount(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldAmount,
		})
	}
	if value, ok := iu.mutation.AddedAmount(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldAmount,
		})
	}
	if value, ok := iu.mutation.OriginalAmount(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldOriginalAmount,
		})
	}
	if value, ok := iu.mutation.AddedOriginalAmount(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldOriginalAmount,
		})
	}
	if value, ok := iu.mutation.RefID(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldRefID,
		})
	}
	if iu.mutation.RefIDCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: item.FieldRefID,
		})
	}
	if value, ok := iu.mutation.BuyURL(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldBuyURL,
		})
	}
	if iu.mutation.BuyURLCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: item.FieldBuyURL,
		})
	}
	if value, ok := iu.mutation.Thumbnail(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldThumbnail,
		})
	}
	if iu.mutation.ThumbnailCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: item.FieldThumbnail,
		})
	}
	if value, ok := iu.mutation.Sku(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldSku,
		})
	}
	if iu.mutation.SkuCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: item.FieldSku,
		})
	}
	if value, ok := iu.mutation.Currency(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldCurrency,
		})
	}
	if value, ok := iu.mutation.NativeAmount(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldNativeAmount,
		})
	}
	if value, ok := iu.mutation.AddedNativeAmount(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldNativeAmount,
		})
	}
	if iu.mutation.NativeAmountCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Column: item.FieldNativeAmount,
		})
	}
	if value, ok := iu.mutation.Condition(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldCondition,
		})
	}
	if value, ok := iu.mutation.Stock(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeInt,
			Value:  value,
			Column: item.FieldStock,
		})
	}
	if value, ok := iu.mutation.AddedStock(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeInt,
			Value:  value,
			Column: item.FieldStock,
		})
	}
	if value, ok := iu.mutation.CreatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: item.FieldCreatedAt,
		})
	}
	if value, ok := iu.mutation.UpdatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: item.FieldUpdatedAt,
		})
	}
	if iu.mutation.UserCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   item.UserTable,
			Columns: []string{item.UserColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: user.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iu.mutation.UserIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   item.UserTable,
			Columns: []string{item.UserColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: user.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if iu.mutation.MetaCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   item.MetaTable,
			Columns: []string{item.MetaColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: itemmeta.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iu.mutation.RemovedMetaIDs(); len(nodes) > 0 && !iu.mutation.MetaCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   item.MetaTable,
			Columns: []string{item.MetaColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: itemmeta.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iu.mutation.MetaIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   item.MetaTable,
			Columns: []string{item.MetaColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: itemmeta.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, iu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{item.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	return n, nil
}

// ItemUpdateOne is the builder for updating a single Item entity.
type ItemUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *ItemMutation
}

// SetName sets the "name" field.
func (iuo *ItemUpdateOne) SetName(s string) *ItemUpdateOne {
	iuo.mutation.SetName(s)
	return iuo
}

// SetAmount sets the "amount" field.
func (iuo *ItemUpdateOne) SetAmount(f float64) *ItemUpdateOne {
	iuo.mutation.ResetAmount()
	iuo.mutation.SetAmount(f)
	return iuo
}

// AddAmount adds f to the "amount" field.
func (iuo *ItemUpdateOne) AddAmount(f float64) *ItemUpdateOne {
	iuo.mutation.AddAmount(f)
	return iuo
}

// SetOriginalAmount sets the "original_amount" field.
func (iuo *ItemUpdateOne) SetOriginalAmount(f float64) *ItemUpdateOne {
	iuo.mutation.ResetOriginalAmount()
	iuo.mutation.SetOriginalAmount(f)
	return iuo
}

// AddOriginalAmount adds f to the "original_amount" field.
func (iuo *ItemUpdateOne) AddOriginalAmount(f float64) *ItemUpdateOne {
	iuo.mutation.AddOriginalAmount(f)
	return iuo
}

// SetUserID sets the "user_id" field.
func (iuo *ItemUpdateOne) SetUserID(u uuid.UUID) *ItemUpdateOne {
	iuo.mutation.SetUserID(u)
	return iuo
}

// SetRefID sets the "ref_id" field.
func (iuo *ItemUpdateOne) SetRefID(s string) *ItemUpdateOne {
	iuo.mutation.SetRefID(s)
	return iuo
}

// SetNillableRefID sets the "ref_id" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableRefID(s *string) *ItemUpdateOne {
	if s != nil {
		iuo.SetRefID(*s)
	}
	return iuo
}

// ClearRefID clears the value of the "ref_id" field.
func (iuo *ItemUpdateOne) ClearRefID() *ItemUpdateOne {
	iuo.mutation.ClearRefID()
	return iuo
}

// SetBuyURL sets the "buy_url" field.
func (iuo *ItemUpdateOne) SetBuyURL(s string) *ItemUpdateOne {
	iuo.mutation.SetBuyURL(s)
	return iuo
}

// SetNillableBuyURL sets the "buy_url" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableBuyURL(s *string) *ItemUpdateOne {
	if s != nil {
		iuo.SetBuyURL(*s)
	}
	return iuo
}

// ClearBuyURL clears the value of the "buy_url" field.
func (iuo *ItemUpdateOne) ClearBuyURL() *ItemUpdateOne {
	iuo.mutation.ClearBuyURL()
	return iuo
}

// SetThumbnail sets the "thumbnail" field.
func (iuo *ItemUpdateOne) SetThumbnail(s string) *ItemUpdateOne {
	iuo.mutation.SetThumbnail(s)
	return iuo
}

// SetNillableThumbnail sets the "thumbnail" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableThumbnail(s *string) *ItemUpdateOne {
	if s != nil {
		iuo.SetThumbnail(*s)
	}
	return iuo
}

// ClearThumbnail clears the value of the "thumbnail" field.
func (iuo *ItemUpdateOne) ClearThumbnail() *ItemUpdateOne {
	iuo.mutation.ClearThumbnail()
	return iuo
}

// SetSku sets the "sku" field.
func (iuo *ItemUpdateOne) SetSku(s string) *ItemUpdateOne {
	iuo.mutation.SetSku(s)
	return iuo
}

// SetNillableSku sets the "sku" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableSku(s *string) *ItemUpdateOne {
	if s != nil {
		iuo.SetSku(*s)
	}
	return iuo
}

// ClearSku clears the value of the "sku" field.
func (iuo *ItemUpdateOne) ClearSku() *ItemUpdateOne {
	iuo.mutation.ClearSku()
	return iuo
}

// SetCurrency sets the "currency" field.
func (iuo *ItemUpdateOne) SetCurrency(s string) *ItemUpdateOne {
	iuo.mutation.SetCurrency(s)
	return iuo
}

// SetNillableCurrency sets the "currency" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableCurrency(s *string) *ItemUpdateOne {
	if s != nil {
		iuo.SetCurrency(*s)
	}
	return iuo
}

// SetNativeAmount sets the "native_amount" field.
func (iuo *ItemUpdateOne) SetNativeAmount(f float64) *ItemUpdateOne {
	iuo.mutation.ResetNativeAmount()
	iuo.mutation.SetNativeAmount(f)
	return iuo
}

// SetNillableNativeAmount sets the "native_amount" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableNativeAmount(f *float64) *ItemUpdateOne {
	if f != nil {
		iuo.SetNativeAmount(*f)
	}
	return iuo
}

// AddNativeAmount adds f to the "native_amount" field.
func (iuo *ItemUpdateOne) AddNativeAmount(f float64) *ItemUpdateOne {
	iuo.mutation.AddNativeAmount(f)
	return iuo
}

// ClearNativeAmount clears the value of the "native_amount" field.
func (iuo *ItemUpdateOne) ClearNativeAmount() *ItemUpdateOne {
	iuo.mutation.ClearNativeAmount()
	return iuo
}

// SetCondition sets the "condition" field.
func (iuo *ItemUpdateOne) SetCondition(s string) *ItemUpdateOne {
	iuo.mutation.SetCondition(s)
	return iuo
}

// SetNillableCondition sets the "condition" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableCondition(s *string) *ItemUpdateOne {
	if s != nil {
		iuo.SetCondition(*s)
	}
	return iuo
}

// SetStock sets the "stock" field.
func (iuo *ItemUpdateOne) SetStock(i int) *ItemUpdateOne {
	iuo.mutation.ResetStock()
	iuo.mutation.SetStock(i)
	return iuo
}

// SetNillableStock sets the "stock" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableStock(i *int) *ItemUpdateOne {
	if i != nil {
		iuo.SetStock(*i)
	}
	return iuo
}

// AddStock adds i to the "stock" field.
func (iuo *ItemUpdateOne) AddStock(i int) *ItemUpdateOne {
	iuo.mutation.AddStock(i)
	return iuo
}

// SetCreatedAt sets the "created_at" field.
func (iuo *ItemUpdateOne) SetCreatedAt(t time.Time) *ItemUpdateOne {
	iuo.mutation.SetCreatedAt(t)
	return iuo
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (iuo *ItemUpdateOne) SetNillableCreatedAt(t *time.Time) *ItemUpdateOne {
	if t != nil {
		iuo.SetCreatedAt(*t)
	}
	return iuo
}

// SetUpdatedAt sets the "updated_at" field.
func (iuo *ItemUpdateOne) SetUpdatedAt(t time.Time) *ItemUpdateOne {
	iuo.mutation.SetUpdatedAt(t)
	return iuo
}

// SetUser sets the "user" edge to the User entity.
func (iuo *ItemUpdateOne) SetUser(u *User) *ItemUpdateOne {
	return iuo.SetUserID(u.ID)
}

// AddMetumIDs adds the "meta" edge to the ItemMeta entity by IDs.
func (iuo *ItemUpdateOne) AddMetumIDs(ids ...uuid.UUID) *ItemUpdateOne {
	iuo.mutation.AddMetumIDs(ids...)
	return iuo
}

// AddMeta adds the "meta" edges to the ItemMeta entity.
func (iuo *ItemUpdateOne) AddMeta(i ...*ItemMeta) *ItemUpdateOne {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return iuo.AddMetumIDs(ids...)
}

// Mutation returns the ItemMutation object of the builder.
func (iuo *ItemUpdateOne) Mutation() *ItemMutation {
	return iuo.mutation
}

// ClearUser clears the "user" edge to the User entity.
func (iuo *ItemUpdateOne) ClearUser() *ItemUpdateOne {
	iuo.mutation.ClearUser()
	return iuo
}

// ClearMeta clears all "meta" edges to the ItemMeta entity.
func (iuo *ItemUpdateOne) ClearMeta() *ItemUpdateOne {
	iuo.mutation.ClearMeta()
	return iuo
}

// RemoveMetumIDs removes the "meta" edge to ItemMeta entities by IDs.
func (iuo *ItemUpdateOne) RemoveMetumIDs(ids ...uuid.UUID) *ItemUpdateOne {
	iuo.mutation.RemoveMetumIDs(ids...)
	return iuo
}

// RemoveMeta removes "meta" edges to ItemMeta entities.
func (iuo *ItemUpdateOne) RemoveMeta(i ...*ItemMeta) *ItemUpdateOne {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return iuo.RemoveMetumIDs(ids...)
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (iuo *ItemUpdateOne) Select(field string, fields ...string) *ItemUpdateOne {
	iuo.fields = append([]string{field}, fields...)
	return iuo
}

// Save executes the query and returns the updated Item entity.
func (iuo *ItemUpdateOne) Save(ctx context.Context) (*Item, error) {
	var (
		err  error
		node *Item
	)
	iuo.defaults()
	if len(iuo.hooks) == 0 {
		if err = iuo.check(); err != nil {
			return nil, err
		}
		node, err = iuo.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ItemMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = iuo.check(); err != nil {
				return nil, err
			}
			iuo.mutation = mutation
			node, err = iuo.sqlSave(ctx)
			mutation.done = true
			return node, err
		})
		for i := len(iuo.hooks) - 1; i >= 0; i-- {
			if iuo.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = iuo.hooks[i](mut)
		}
		v, err := mut.Mutate(ctx, iuo.mutation)
		if err != nil {
			return nil, err
		}
		nv, ok := v.(*Item)
		if !ok {
			return nil, fmt.Errorf("unexpected node type %T returned from ItemMutation", v)
		}
		node = nv
	}
	return node, err
}

// SaveX is like Save, but panics if an error occurs.
func (iuo *ItemUpdateOne) SaveX(ctx context.Context) *Item {
	node, err := iuo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (iuo *ItemUpdateOne) Exec(ctx context.Context) error {
	_, err := iuo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (iuo *ItemUpdateOne) ExecX(ctx context.Context) {
	if err := iuo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (iuo *ItemUpdateOne) defaults() {
	if _, ok := iuo.mutation.UpdatedAt(); !ok {
		v := item.UpdateDefaultUpdatedAt()
		iuo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (iuo *ItemUpdateOne) check() error {
	if _, ok := iuo.mutation.UserID(); iuo.mutation.UserCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "Item.user"`)
	}
	return nil
}

func (iuo *ItemUpdateOne) sqlSave(ctx context.Context) (_node *Item, err error) {
	_spec := &sqlgraph.UpdateSpec{
		Node: &sqlgraph.NodeSpec{
			Table:   item.Table,
			Columns: item.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: item.FieldID,
			},
		},
	}
	id, ok := iuo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Item.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := iuo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, item.FieldID)
		for _, f := range fields {
			if !item.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != item.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := iuo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := iuo.mutation.Name(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldName,
		})
	}
	if value, ok := iuo.mutation.Amount(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldAmount,
		})
	}
	if value, ok := iuo.mutation.AddedAmount(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldAmount,
		})
	}
	if value, ok := iuo.mutation.OriginalAmount(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldOriginalAmount,
		})
	}
	if value, ok := iuo.mutation.AddedOriginalAmount(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldOriginalAmount,
		})
	}
	if value, ok := iuo.mutation.RefID(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldRefID,
		})
	}
	if iuo.mutation.RefIDCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: item.FieldRefID,
		})
	}
	if value, ok := iuo.mutation.BuyURL(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldBuyURL,
		})
	}
	if iuo.mutation.BuyURLCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: item.FieldBuyURL,
		})
	}
	if value, ok := iuo.mutation.Thumbnail(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldThumbnail,
		})
	}
	if iuo.mutation.ThumbnailCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: item.FieldThumbnail,
		})
	}
	if value, ok := iuo.mutation.Sku(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldSku,
		})
	}
	if iuo.mutation.SkuCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Column: item.FieldSku,
		})
	}
	if value, ok := iuo.mutation.Currency(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldCurrency,
		})
	}
	if value, ok := iuo.mutation.NativeAmount(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldNativeAmount,
		})
	}
	if value, ok := iuo.mutation.AddedNativeAmount(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldNativeAmount,
		})
	}
	if iuo.mutation.NativeAmountCleared() {
		_spec.Fields.Clear = append(_spec.Fields.Clear, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Column: item.FieldNativeAmount,
		})
	}
	if value, ok := iuo.mutation.Condition(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldCondition,
		})
	}
	if value, ok := iuo.mutation.Stock(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeInt,
			Value:  value,
			Column: item.FieldStock,
		})
	}
	if value, ok := iuo.mutation.AddedStock(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeInt,
			Value:  value,
			Column: item.FieldStock,
		})
	}
	if value, ok := iuo.mutation.CreatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: item.FieldCreatedAt,
		})
	}
	if value, ok := iuo.mutation.UpdatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: item.FieldUpdatedAt,
		})
	}
	if iuo.mutation.UserCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   item.UserTable,
			Columns: []string{item.UserColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: user.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iuo.mutation.UserIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   item.UserTable,
			Columns: []string{item.UserColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: user.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if iuo.mutation.MetaCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   item.MetaTable,
			Columns: []string{item.MetaColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: itemmeta.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iuo.mutation.RemovedMetaIDs(); len(nodes) > 0 && !iuo.mutation.MetaCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   item.MetaTable,
			Columns: []string{item.MetaColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: itemmeta.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := iuo.mutation.MetaIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   item.MetaTable,
			Columns: []string{item.MetaColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: itemmeta.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Item{config: iuo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, iuo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{item.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	return _node, nil
}
